//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Orange
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int  Length = 14;
extern int  Price  = PRICE_CLOSE;
double mad[];
double med[];
double trbuffer[];
double mtr[];
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,mad);
      SetIndexBuffer(1,mtr);
      SetIndexBuffer(2,med);
      SetIndexBuffer(3,trbuffer);
         Length = MathMax(Length,2);
      IndicatorShortName("Median absolute deviation and Median True Range ("+Length+")");
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
 
   for(int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         med[i] = iMedian(price,Length,i,0);
         mad[i] = iMedian(MathAbs(price-med[i]),Length,i,1);
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) trbuffer[i]=high-low;
      else
        {
         double prevclose=Close[i+1];
            trbuffer[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
        }
        mtr[i]= iMedian(trbuffer[i],Length,i,2);
   }      
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workMed[][3];
double sortMed[];
double iMedian(double price, int period, int i, int instanceNo=0)
{
   static int midlea=0;
   static int midleb=0;
      if (ArrayRange(workMed,0)!=Bars) ArrayResize(workMed,Bars); int r = Bars-i-1;
      if (ArraySize(sortMed)!=period)
      {
           ArrayResize(sortMed,period);
              if ((period%2) == 0)
                    { midlea = (period/2)-1; midleb = period/2; }
              else  { midlea = (period-1)/2; midleb = midlea;   } 
      }            
   
   //
   //
   //
   //
   //

   workMed[r][instanceNo] = price;
      for (int k=0; k<period; k++) sortMed[k] = workMed[r-k][instanceNo]; ArraySort(sortMed);
      return((sortMed[midlea]+sortMed[midleb])/2.0);
}